<?
/* Created By: Dave Gibbons      dave@dave.vc           */
/* Aug 2008                                             */
/* Cisco phone reboot/other operations script           */

/* this script should allow us to restart a phone based on the phone extension */
/* it will read the phone info from the sip_show_peers text file */

$username = "jf903jsmfld93";
$password = "94jisdnhjdyw2euha";

$operation = $argv[1];
$exten = $argv[2];

$ips = array();
exec("asterisk -r -x \"sip show peers\"",$ips);

$ip = false;
foreach($ips as $key => $data){
	if(strpos($data,$exten."/".$exten) !== false){
		$data = preg_split("/[\s]+/", $data);
		$ip = $data[1];
		$data = preg_split("/[\/]+/", $data[0]);
		//echo $data[0]." and ip is ".$ip."\n";
	}
}
if(!$ip)
	die("Couldn't find extension: ".$exten."\n");

$actions['reboot'][0] = array(0 => "Key:Settings", 1 => "2");
$actions['reboot'][1] = array(0 => "Key:KeyPadStar", 1 => ".3");
$actions['reboot'][2] = array(0 => "Key:KeyPadStar", 1 => ".3");
$actions['reboot'][3] = array(0 => "Key:KeyPadPound", 1 => ".3");
$actions['reboot'][4] = array(0 => "Key:KeyPadStar", 1 => ".3");
$actions['reboot'][5] = array(0 => "Key:KeyPadStar", 1 => ".3");

$actions['setimage'][0] = array(0 => "Key:Settings", 1 => ".3");
$actions['setimage'][1] = array(0 => "Key:KeyPad1", 1 => ".3");
$actions['setimage'][2] = array(0 => "Key:KeyPad2", 1 => "5");
$actions['setimage'][3] = array(0 => "Key:KeyPad2", 1 => "3");
$actions['setimage'][4] = array(0 => "Key:Soft1", 1 => "7");
$actions['setimage'][5] = array(0 => "Key:Soft2", 1 => "1");
$actions['setimage'][6] = array(0 => "Key:Soft3", 1 => "1");
$actions['setimage'][7] = array(0 => "Key:Soft3", 1 => "1");

//$actions['setalttftp'][0] = array(0 => "Key:Settings", 1=> "1");
//$actions['setalttftp'][1] = array(0 => "Key:KeyPad2", 1=> "1");
//$actions['setalttftp'][1] = array(0 => "Key:KeyPadStar", 1 => ".3");
//$actions['setalttftp'][2] = array(0 => "Key:KeyPadStar", 1 => ".3");
//$actions['setalttftp'][3] = array(0 => "Key:KeyPadPound", 1 => "5");
//$actions['setalttftp'][4] = array(0 => "Key:Settings", 1=> "1");

$actions['setalttftp'][0] = array(0 => "Key:Settings", 1=> "1");
//$actions['setalttftp'][1] = array(0 => "Key:KeyPad2", 1=> "1");
$actions['setalttftp'][1] = array(0 => "Key:KeyPad2", 1 => "1");
$actions['setalttftp'][2] = array(0 => "Key:KeyPad2", 1 => "0");
$actions['setalttftp'][3] = array(0 => "Key:KeyPad24", 1 => "0");
$actions['setalttftp'][4] = array(0 => "Key:Soft2", 1 => "5");
$actions['setalttftp'][5] = array(0 => "Key:Soft3", 1 => "5");
$actions['setalttftp'][6] = array(0 => "Key:Settings", 1=> "1");

foreach($actions[$operation] as $key => $data){
	echo push2phone($ip,$data[0],$username,$password);
	sleep($data[1]);
}


/* this is the function that does all of the dirty work. */
/* from http://www.voip-info.org/wiki-Cisco+79XX+XML+Push */


function push2phone($ip, $uri, $uid, $pwd){
  $auth = base64_encode($uid.":".$pwd);
  $xml  = "<CiscoIPPhoneExecute><ExecuteItem Priority=\"0\" URL=\"".$uri."\"/></CiscoIPPhoneExecute>";
  echo $xml."\n";
  $xml  = "XML=".urlencode($xml);
  
  $post  = "POST /CGI/Execute HTTP/1.0\r\n";
  $post .= "Host: $ip\r\n";
  $post .= "Authorization: Basic $auth\r\n";
  $post .= "Connection: close\r\n";
  $post .= "Content-Type: application/x-www-form-urlencoded\r\n";
  $post .= "Content-Length: ".strlen($xml)."\r\n\r\n";
  
  $fp = fsockopen ( $ip, 80, $errno, $errstr, 30);
  if(!$fp){ echo "$errstr ($errno)<br>\n"; }
  else
  {
    fputs($fp, $post.$xml);
    flush();
    while (!feof($fp))
    {
     $response .= fgets($fp, 128);
     flush();
    }
  }
  return $response;
  }
?>
